{% extends 'base.html' %}
{% block content %}
<div style="margin-top: 80px;">
    <h1 data-aos="fade-up">Click to <span class="typed-words"></span></h1>
</div>
<div class="card-body scroll" id="kotak">
    <p class="card-text" id="result"></p>
</div>
<div id="isiform" style="margin-top: 15px; margin-bottom: 15px;">
    <h3 class="h5 text-white mb-3">Please Choose and Input</h3>
    <form>
        <label class="col-md-3 text-left h5 text-white">Customer</label>
        <label class="col-md-1 text-left h5 text-white">:</label>
        <!-- <input id="customer" type="text" class="col-md-7 text-center" placeholder="PT Ludes Developer"></input> -->
        <select id="customer" name="customer" class="col-md-7 text-center">
        </select>
        <label class="col-md-3 text-left h5 text-white">Prepared by</label>
        <label class="col-md-1 text-left h5 text-white">:</label>
        <!-- <input id="prepared" type="text" class="col-md-7 text-center" placeholder="Luthfi Anandra"></input> -->
        <select id="prepared" name="prepared" class="col-md-7 text-center">
        </select>
        <label class="col-md-3 text-left h5 text-white">Reviewed by</label>
        <label class="col-md-1 text-left h5 text-white">:</label>
        <select id="review" name="review" class="col-md-7 text-center">
        </select>
        <!-- <input id="review" type="text" class="col-md-7 text-center" placeholder="Dedy Darisman"></input> -->
        <label class="col-md-3 text-left h5 text-white">PIC</label>
        <label class="col-md-1 text-left h5 text-white">:</label>
        <input id="pic" type="text" class="col-md-7 text-center" value="Input Name PIC"></input>
        <label class="col-md-3 text-left h5 text-white">Periode</label>
        <label class="col-md-1 text-left h5 text-white">:</label>
        <!-- <input type="text" class="col-md-5 text-center" placeholder="December"></input>  -->
        <!-- <input type="text" class="col-md-2,9 text-center" placeholder="2021"></input> -->
        <select id="bulan" name="bulan" class="col-md-2.9 text-center"
            style="width: 318px; height: 34px; text-align-last: center;">
            <option value="January">January</option>
            <option value="February">February</option>
            <option value="March">March</option>
            <option value="April">April</option>
            <option value="May">May</option>
            <option value="June">June</option>
            <option value="July">July</option>
            <option value="August">August</option>
            <option value="September">September</option>
            <option value="October">October</option>
            <option value="November">November</option>
            <option value="December">December</option>
        </select>
        <select id="tahun" name="tahun" class="col-md-2.9 text-center"
            style="width: 123px; height: 34px; text-align-last: center;"></select>
    </form>
</div>
<div id="allcheckbox" style="padding-left: 25px;">
    <div class="col-md-12 form-check form-check-inline">
        <label class="col-md-3 text-left h5 text-white" style="margin-right: 17px;">Type Report</label>
        <label class="col-md-1 text-left h5 text-white">:</label>
        <input class="col-md-1 text-left h6 text-white" type="checkbox" id="inlineCheckbox"
            value="Routing and Switching" name='log_checkbox' style="margin-right: 5px;">
        <label class="col-md-12 text-left h6 text-white" for="inlineCheckbox">Routing and Switching</label>
    </div>
    <div class="col-md-12 form-check form-check-inline">
        <label class="col-md-3 text-left h5 text-white" style="margin-right: 17px;"></label>
        <label class="col-md-1 text-left h5 text-white"></label>
        <input class="col-md-1 text-left h6 text-white" type="checkbox" id="inlineCheckbox" value="Collaboration"
            name='log_checkbox' style="margin-right: 5px;">
        <label class="col-md-12 text-left h6 text-white" for="inlineCheckbox">Collaboration</label>
    </div>
    <div class="col-md-12 form-check form-check-inline">
        <label class="col-md-3 text-left h5 text-white" style="margin-right: 17px;"></label>
        <label class="col-md-1 text-left h5 text-white"></label>
        <input class="col-md-1 text-left h6 text-white" type="checkbox" id="inlineCheckbox" value="F5"
            name='log_checkbox' style="margin-right: 5px;">
        <label class="col-md-12 text-left h6 text-white" for="inlineCheckbox">F5</label>
    </div>
    <div class="col-md-12 form-check form-check-inline">
        <label class="col-md-3 text-left h5 text-white" style="margin-right: 17px;"></label>
        <label class="col-md-1 text-left h5 text-white"></label>
        <input class="col-md-1 text-left h6 text-white" type="checkbox" id="inlineCheckbox" value="FortiGate"
            name='log_checkbox' style="margin-right: 5px;">
        <label class="col-md-12 text-left h6 text-white" for="inlineCheckbox">FortiGate</label>
    </div>
</div>
<!--input type="submit" value="Submit"-->
<div class="ludes-margin-bottom" style="margin-top: 20px;">
    <p class="btn btn-primary" id="generatebutton" onclick="triggerSSE()">Generate</p>
    <p class="btn btn-primary hidebutton" id="regeneratebutton" onclick="triggerSSE()">Regenerate</p>
    <a class="btn btn-primary hidebutton" id="downloadbutton"
        href="{{ url_for('static', filename='result/preventive_maintenance.zip') }}" download>Download .zip</a>
    <!-- <a class="btn btn-primary hidebutton" id="downloadbuttonxlsx" href="{{ url_for('static', filename='result/preventive_maintenance.xlsx') }}" download>Download .xlsx</a> -->
</div>
<script src="{{ url_for('static', filename='bootstrap/js/typed.js') }}"></script>
<script>
    var typed = new Typed('.typed-words', {
        strings: ["Generate Report"],
        typeSpeed: 80,
        backSpeed: 80,
        backDelay: 4000,
        startDelay: 1000,
        loop: true,
        showCursor: true
    });
</script>
<!--Dropdown Customer from JSON API-->
<script>
    let dropdown1 = document.getElementById('customer');
    dropdown1.length = 0;
    let defaultOption1 = document.createElement('option');
    defaultOption1.text = 'Choose Name Customer';
    dropdown1.add(defaultOption1);
    dropdown1.selectedIndex = 0;
        // const urlcs = "{{ url_for('api_cs') }}";
        // const request1 = new XMLHttpRequest();
        // request1.open('GET', urlcs, true);
        // request1.onload = function() {
        // if (request1.status === 200) {
        //     const data = JSON.parse(request1.responseText);
        //     let option;
        //     for (let i = 0; i < data.customer.length; i++) {
        //     option = document.createElement('option');
        //     option.text = data.customer[i].name;
        //     option.value = data.customer[i].name;
        //     dropdown1.add(option);
        //     }
        // } else {
        //     // Reached the server, but it returned an error
        // }   
        // }
        // request1.onerror = function() {
        // console.error('An error occurred fetching the JSON from ' + urlcs);
        // };
        // request1.send();
</script>
<!--Dropdown Engineer Prepared from JSON API-->
<script>
    let dropdown2 = document.getElementById('prepared');
    dropdown2.length = 0;
    let defaultOption2 = document.createElement('option');
    defaultOption2.text = 'Choose Name Engineer Prepared';
    dropdown2.add(defaultOption2);
    dropdown2.selectedIndex = 0;
        // const urle = "{{ url_for('api_engineer') }}";
        // const request2 = new XMLHttpRequest();
        // request2.open('GET', urle, true);
        // request2.onload = function() {
        // if (request2.status === 200) {
        //     const data = JSON.parse(request2.responseText);
        //     let option;
        //     for (let i = 0; i < data.engineer.length; i++) {
        //     option = document.createElement('option');
        //     option.text = data.engineer[i].engineer_name;
        //     option.value = data.engineer[i].engineer_name;
        //     dropdown2.add(option);
        //     }
        // } else {
        //     // Reached the server, but it returned an error
        // }   
        // }
        // request2.onerror = function() {
        // console.error('An error occurred fetching the JSON from ' + urle);
        // };
        // request2.send();
</script>
<!--Dropdown Engineer Review from JSON API-->
<script>
    let dropdown3 = document.getElementById('review');
    dropdown3.length = 0;
    let defaultOption3 = document.createElement('option');
    defaultOption3.text = 'Choose Name Engineer Review';
    dropdown3.add(defaultOption3);
    dropdown3.selectedIndex = 0;
        // const urler = "{{ url_for('api_engineer') }}";
        // const request3 = new XMLHttpRequest();
        // request3.open('GET', urler, true);
        // request3.onload = function() {
        // if (request3.status === 200) {
        //     const data = JSON.parse(request3.responseText);
        //     let option;
        //     for (let i = 0; i < data.engineer.length; i++) {
        //     option = document.createElement('option');
        //     option.text = data.engineer[i].engineer_name;
        //     option.value = data.engineer[i].engineer_name;
        //     dropdown3.add(option);
        //     }
        // } else {
        //     // Reached the server, but it returned an error
        // }   
        // }
        // request3.onerror = function() {
        // console.error('An error occurred fetching the JSON from ' + urler);
        // };
        // request3.send();
</script>
<script type="text/javascript">
    window.onload = function () {
        //Reference the DropDownList.
        var tahun = document.getElementById("tahun");

        //Determine the Current Year.
        var currentYear = (new Date()).getFullYear();

        //Loop and add the Year values to DropDownList.
        for (var i = 1990; i <= currentYear; i++) {
            var option = document.createElement("OPTION");
            option.innerHTML = i;
            option.value = i;

            if (currentYear == i) {
                option.selected = 'true';
            }
            tahun.appendChild(option);
        }
    };
</script>
<script>
    function triggerSSE() {
        var my_string = '';
        var check_box_values = $('input:checked').map(function () {
            return this.value;
        }).get();
        console.log(check_box_values);
        for (i = 0; i < check_box_values.length; i++) {
            my_string = my_string.concat(check_box_values[i]) + "-";
        }
        console.log(my_string);

        var Customer = document.getElementById('customer').value;
        var Review = document.getElementById('review').value;
        var Prepared = document.getElementById('prepared').value;
        var Pic = document.getElementById('pic').value;
        var Bulan = document.getElementById('bulan').value;
        var Tahun = document.getElementById('tahun').value;
        console.log('testos')
        console.log(Customer)
        if ($('input:checked').length != 0 && Customer != 'Choose Name Customer' && Prepared != 'Choose Name Engineer Prepared' && Review != 'Choose Name Engineer Review' && typeof (EventSource) !== "undefined") {
            var hidebtn = document.getElementById("downloadbutton");
            // var hidebtnxlsx = document.getElementById("downloadbuttonxlsx");
            var hidebtn1 = document.getElementById("generatebutton");
            var hidebtn2 = document.getElementById("regeneratebutton");
            var hideisiform = document.getElementById("isiform");
            var hidecheck = document.getElementById('allcheckbox');
            // var hidekotak = document.getElementById("kotak");
            var source = new EventSource("/report/generate?customer=" + Customer + "&review=" + Review + "&prepared=" + Prepared + "&pic=" + Pic + "&bulan=" + Bulan + "&tahun=" + Tahun + "&my_string=" + my_string + "");
            var str_find = "Finished";
            hidebtn.style.display = "none";
            // hidebtnxlsx.style.display = "none";
            hidebtn1.style.display = "none";
            hidebtn2.style.display = "none";
            hideisiform.style.display = "none";
            hidecheck.style.display = "none";
            // hidekotak.style.display = "none";
            source.onmessage = function (event) {
                //var txt = even.data;
                // console.log(event.data);
                document.getElementById("result").innerHTML += event.data + "<br>";
                updateScroll();
                //alert(even.data);
                //var obj = JSON.parse(txt);
                //document.getElementById("result").innerHTML += obj.total_print + "<br>";
                //console.log(obj.total_print);
                event_check = event.data.includes("Finished");
                if (event_check == true) {
                    source.close()
                    hidebtn.style.display = "inline";
                    // hidebtnxlsx.style.display = "inline";
                    hidebtn1.style.display = "none";
                    hidebtn2.style.display = "inline";
                    hideisiform.style.display = "inline";
                    hidecheck.style.display = "inline";
                    // hidekotak.style.display = "none";
                    //alert('ketemu')
                };
            };

        } else {
            alert('Please Input/Select All Required Field')
            // document.getElementById("result").innerHTML = "Sorry, your browser does not support server-sent events...";
        }

    }

    function updateScroll() {
        var element = document.getElementById("kotak");
        element.scrollTop = element.scrollHeight;
    }
</script>
{% endblock %}